/******************************************************************************
 *
 * (c) 2020 Copyright, Real-Time Innovations, Inc. (RTI)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 ******************************************************************************/ 

/**
 * @file nano_core.h
 * @brief Nano Core API.
 * 
 * This header file should be included to access the services provided by the
 * Nano Core library.
 * 
 */

#ifndef nano_core_h
#define nano_core_h


#ifdef __cplusplus
extern "C" {
#endif

#include "nano/nano_core_config.h"
#include "nano/nano_core_osapi.h"
#include "nano/nano_core_xrce.h"
#include "nano/nano_core_cdr.h"
#include "nano/nano_core_log.h"

#ifdef __cplusplus
}	/* extern "C" */
#endif

#endif /* nano_core_h */
