/******************************************************************************
 *
 * (c) 2020 Copyright, Real-Time Innovations, Inc. (RTI)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 ******************************************************************************/ 

/**
 * @file nano_core_xrce.h
 * @brief Core XRCE API definitions.
 * 
 * This header file contains definitions for core API used by the XRCE
 * protocol and throughout its implementation.
 * 
 */

#ifndef nano_core_xrce_h
#define nano_core_xrce_h

#include "nano/nano_core_xrce_basic.h"
#include "nano/nano_core_xrce_repr.h"
#include "nano/nano_core_xrce_transport.h"
#include "nano/nano_core_xrce_activity.h"
#include "nano/nano_core_xrce_message.h"
#include "nano/nano_core_xrce_session.h"

#endif /* nano_core_xrce_h */
